/*
 * ngx_http_oceanbase_keepalive.h
 *
 * Copyright (C) 2019 Ant Financial (Hang Zhou) Network Technology Co., Ltd.
 *
 */

#ifndef NGX_HTTP_OCEANBASE_KEEPALIVE_H
#define NGX_HTTP_OCEANBASE_KEEPALIVE_H

#include "ngx_http_oceanbase_upstream.h"
#include <ngx_core.h>
#include <ngx_http.h>
#include <nginx.h>
#include "ngx_tpcc_txn.h"

typedef struct {
    ngx_http_upstream_oceanbase_srv_conf_t  *srv_conf;
    ngx_queue_t                          queue;
    ngx_connection_t                    *connection;
    oceanbase_connection                *oceanbase_con;
    ngx_str_t                            name;
    ngx_uint_t                           used;
} ngx_http_oceanbase_keepalive_cache_t;


char *ngx_http_upstream_oceanbase_keepalive(ngx_conf_t *cf, ngx_command_t *cmd, void *conf);

ngx_int_t ngx_http_oceanbase_keepalive_init(ngx_pool_t *pool, ngx_http_upstream_oceanbase_srv_conf_t *obscf);

ngx_int_t ngx_http_oceanbase_keepalive_get_peer_single(ngx_peer_connection_t *pc,
        												ngx_http_upstream_oceanbase_peer_data_t *obp,
        												ngx_http_upstream_oceanbase_srv_conf_t *obscf);

void ngx_http_oceanbase_keepalive_free_peer(ngx_peer_connection_t *pc,
        												ngx_http_upstream_oceanbase_peer_data_t *obp,
        												ngx_http_upstream_oceanbase_srv_conf_t *obscf,
        												ngx_uint_t  state);

#endif /* NGX_HTTP_OCEANBASE_KEEPALIVE_H */

