/*
 * ngx_http_oceanbase_util.h
 *
 * Copyright (C) 2019 Ant Financial (Hang Zhou) Network Technology Co., Ltd.
 *
 */
 
#ifndef NGX_HTTP_OCEANBASE_UTIL_H
#define NGX_HTTP_OCEANBASE_UTIL_H
#include <nginx.h>
#include <ngx_core.h>
#include <ngx_http.h>
#include "ngx_tpcc_txn.h"

#define ngx_http_oceanbase_strcmp_const(a, b)                                  \
        ngx_strncmp(a, b, sizeof(b) - 1)

#ifndef ngx_copy_const_str
#define ngx_copy_const_str(p, s)  ngx_copy(p, s, sizeof(s) - 1)
#endif


void ngx_http_upstream_oceanbase_init(ngx_http_request_t *r);
void ngx_http_upstream_oceanbase_init_request(ngx_http_request_t *r);
void ngx_http_upstream_oceanbase_finalize_request(ngx_http_request_t *r,
    ngx_http_upstream_t *u, ngx_int_t rc);
void ngx_http_upstream_oceanbase_next(ngx_http_request_t *r,
    ngx_http_upstream_t *u, ngx_int_t rc);
ngx_int_t ngx_http_upstream_oceanbase_test_connect(ngx_connection_t *c);
ngx_uint_t ngx_http_oceanbase_queue_size(ngx_queue_t *queue);
size_t ngx_http_oceanbase_get_num_size(uint64_t i);

#define ngx_http_oceanbase_nelems(x) (sizeof(x) / sizeof(x[0]))

#endif /* NGX_HTTP_OCEANBASE_UTIL_H */

