/*
 * ngx_tpcc_delivery_pool.h
 * 
 * Copyright (C) 2019 Ant Financial (Hang Zhou) Network Technology Co., Ltd.
 *
 */
#ifndef NGX_TPCC_DEL_THREAD_POOL
#define  NGX_TPCC_DEL_THREAD_POOL
#include <ngx_config.h>
#include <ngx_core.h>
#include <ngx_http.h>
#include <ngx_thread_pool.h>
#include <ngx_thread.h>
#include "ngx_tpcc_common.h"

typedef pthread_mutex_t  ngx_thread_mutex_t;

extern ngx_thread_pool_t * g_del_thread_pool;

extern ngx_int_t del_task_pool_init();
extern ngx_thread_task_t* get_del_task_from_pool();
extern ngx_int_t return_task_to_pool(DeliveryTask* del_task);
extern void del_thread_completion(ngx_event_t *ev);

typedef struct ngx_thread_task_pool_s {
    ngx_thread_mutex_t mtx;
    ngx_thread_task_t** tasks;
    ngx_int_t pool_size;
	long long int gets;
	long long int puts;
    uint32_t * used_flag;
} ngx_thread_task_pool_t;
#endif
