/*
 * ngx_tpcc_txn.h is the declaration txn processing routine
 *
 * Copyright (C) 2019 Ant Financial (Hang Zhou) Network Technology Co., Ltd.
 *
 */

#ifndef __NGINX_TPCC_TXN_H__
#define __NGINX_TPCC_TXN_H__
#include <sql.h>
#include <sqlext.h>
#include <sqltypes.h>
#include "ngx_tpcc_common.h"

static inline int gen_response_head(char* response, char* title)
{
    return  sprintf(response,"<html>"
                "<head>"
                "<title>%s</title>"
                "</head>"
				"<pre>"
                "<body>"
				"<h3>%s</h3>", title, title);

}

#define error_info_page "<html>"\
                "<head>"\
                "<title>Error Page</title>"\
                "</head>"\
				"<pre>"\
                "<body>"\
				"%s<br>"\
				"<a href=\"/tpcc/logon\">Exit</a>"\
				"</body>"\
				"</pre>"\
				"</html>"

#define parse_param(params, param, bnull) \
                        do{\
                            int j = 0; \
                            int bfloat = 0;\
                            while((*params >= '0' && *params <= '9') || *params == '.' ){\
                                params ++; j ++;\
                                if(*params == '.'){\
                                    bfloat = 1;\
                                }else{}\
                            }\
                            if(j == 0){\
                                bnull = true;\
                            }else{\
                                if(!bfloat){\
                                    param = ngx_atoi(params - j, j);\
                                }else{\
                                    param = (ngx_atofp(params - j, j, 2) * 1.0) /100.0;\
                                }\
                                bnull = false;\
                            }\
                        }\
                        while(0)

#define logon_page "<html>"\
                      "<head>"\
                      "<title>OceanBase|logon</title>"\
                      "</head>"\
                      "<body>"\
					"<pre>"\
					"<form action=\"logon\" method=\"post\" id=\"no_forms\">"\
					"Please input warehouse and district ids <br>"\
					"Warehouse: <input name=\"w_id\"/> <br>"\
                    "District:  <input name=\"sl_d_id\"/> <br>"\
                    "<button type=\"submit\" id=\"logon\" >logon</button>"\
					"</form>"\
					"</pre>"\
					"</body></html>"

#define menu_page "<html>"\
					"<pre>"\
					"<head>"\
    					"<title>OceanBase|TPC-C|TxnMenu</title>"\
					"</head>"\
					"<body>"\
    					"<h3>TPC-C Transaction Menu</h3>"\
            			"<a href=\"/tpcc/new-order-input%s\">new-order</a><br>"\
            			"<a href=\"/tpcc/payment-input%s\">payment</a><br>"\
            			"<a href=\"/tpcc/delivery-input%s\">delivery</a><br>"\
            			"<a href=\"/tpcc/order-status-input%s\">order-status</a><br>"\
            			"<a href=\"/tpcc/stock-level-input%s\">stock-level</a><br>"\
            			"<a href=\"/tpcc/logon\">Exit</a>"\
					"</body>"\
					"</pre>"\
				  "</html>"

#define hidden_input_info	"?t_id=%d&w_id=%d&sl_d_id=%d"

#define no_input_page	"<html>"\
						"<head>"\
	                		"<title>OceanBase|new-order</title>"\
                		"</head>"\
						"<pre>"\
                		"<body>"\
    					"<h3>NEW ORDER</h3>"\
						"<form action=\"new-order\" method=\"post\" id=\"no_forms\">"\
						"<input type=\"hidden\" name=\"t_id\" value=\"%d\"/>"\
						"<input type=\"hidden\" name=\"sl_d_id\" value=\"%d\"/>"\
						"Warehouse: <input name=\"w_id\" value=\"%d\" readonly/> "\
                        "District:  <input name=\"d_id\"/>          Date: <br>"\
                        "Customer:  <input name=\"c_id\"/>          Name:   Credit:   Disc:<br>"\
                        "Order Number:   Number of Lines:   W_tax:   D_tax:<br>"\
                        "Supp_W               Item_Id               Qty             Item Name  Stock  B/G  Price  Amount<br>"\
                        "<input name=\"s00\"/> <input name=\"i00\"/> <input name=\"q00\"/><br>"\
                        "<input name=\"s01\"/> <input name=\"i01\"/> <input name=\"q01\"/><br>"\
                        "<input name=\"s02\"/> <input name=\"i02\"/> <input name=\"q02\"/><br>"\
                        "<input name=\"s03\"/> <input name=\"i03\"/> <input name=\"q03\"/><br>"\
                        "<input name=\"s04\"/> <input name=\"i04\"/> <input name=\"q04\"/><br>"\
                        "<input name=\"s05\"/> <input name=\"i05\"/> <input name=\"q05\"/><br>"\
                        "<input name=\"s06\"/> <input name=\"i06\"/> <input name=\"q06\"/><br>"\
                        "<input name=\"s07\"/> <input name=\"i07\"/> <input name=\"q07\"/><br>"\
                        "<input name=\"s08\"/> <input name=\"i08\"/> <input name=\"q08\"/><br>"\
                        "<input name=\"s09\"/> <input name=\"i09\"/> <input name=\"q09\"/><br>"\
                        "<input name=\"s10\"/> <input name=\"i10\"/> <input name=\"q10\"/><br>"\
                        "<input name=\"s11\"/> <input name=\"i11\"/> <input name=\"q11\"/><br>"\
                        "<input name=\"s12\"/> <input name=\"i12\"/> <input name=\"q12\"/><br>"\
                        "<input name=\"s13\"/> <input name=\"i13\"/> <input name=\"q13\"/><br>"\
                        "<input name=\"s14\"/> <input name=\"i14\"/> <input name=\"q14\"/><br>"\
                        "<button type=\"submit\" id=\"doSubmit\">Submit</button><br>"\
						"</form>"\
                        "<a href=\"/tpcc/txn-menu%s\">Menu</a>"\
						"</body>"\
						"</pre>"\
						"</html>"

#define pay_input_page	"<html>"\
                        	"<head>"\
                            "<title>OceanBase|payment</title>"\
                        	"</head>"\
							"<pre>"\
                        	"<body>"\
    						"<h3>PAYMENT</h3>"\
							"<form action=\"payment\" method=\"post\" id=\"pay_forms\">"\
							"<input type=\"hidden\" name=\"t_id\" value=\"%d\"/>"\
							"<input type=\"hidden\" name=\"sl_d_id\" value=\"%d\"/>"\
							"Warehouse: <input name=\"w_id\" value=\"%d\" readonly/> "\
                        	"District: 	     <input name=\"d_id\"/>      Date: <br>"\
                        	"Customer:  <input name=\"c_id\"/> Cust-Warehouse: <input name=\"c_w_id\"/>"\
                        	"      Cust-District: <input name=\"c_d_id\"/> <br>"\
                        	"Name:      <input name=\"c_last\"/>        Since: <br>"\
                        	"                                    Credit:<br>"\
                        	"                                    Disc:<br>"\
                        	"                                    Phone:<br>"\
                        	"Amount paid: $<input name=\"h_amount\"/> <br>"\
                        	"New Cust Balance: <br>"\
                        	"Credit Limit: <br>"\
                        	"Cust-Data: <br>"\
                        	"<button type=\"submit\" id=\"doSubmit\">Submit</button>"\
							"</form>"\
                        	"<a href=\"/tpcc/txn-menu%s\">Menu</a>"\
							"</body>"\
							"</pre>"\
						"</html>"

#define del_input_page		"<html>"\
                            	"<head>"\
                            	"<title>OceanBase|delivery</title>"\
                            	"</head>"\
							"<pre>"\
                            "<body>"\
    						"<h3>DELIVERY</h3>"\
							"<form action=\"delivery\" method=\"post\" id=\"del_forms\">"\
							"<input type=\"hidden\" name=\"t_id\" value=\"%d\"/>"\
							"<input type=\"hidden\" name=\"sl_d_id\" value=\"%d\"/>"\
							"Warehouse: 		<input name=\"w_id\" value=\"%d\" readonly/> <br>"\
                            "Carrier Number: 	<input name=\"o_carrier_id\"/> <br>"\
                            "Execution  Status: <br>"\
                            "<button type=\"submit\" id=\"doSubmit\" >Submit</button>"\
							"</form>"\
                            "<a href=\"/tpcc/txn-menu%s\">Menu</a>"\
							"</body>"\
							"</pre>"\
							"</html>"

#define os_input_page	"<html>"\
                            "<head>"\
                            "<title>OceanBase|order-status</title>"\
                            "</head>"\
							"<pre>"\
                            "<body>"\
    					"<h3>ORDER STATUS</h3>"\
						"<form action=\"order-status\" method=\"post\" id=\"os_forms\">"\
						"<input type=\"hidden\" name=\"t_id\" value=\"%d\"/>"\
						"<input type=\"hidden\" name=\"sl_d_id\" value=\"%d\"/>"\
						"Warehouse:  <input name=\"w_id\" value=\"%d\" readonly/> "\
                        "District:   <input name=\"d_id\" />   Date: <br>"\
                        "Customer:   <input name=\"c_id\"/> <br>"\
                        "Name:       <input name=\"c_last\"/> <br>"\
                        "Cust-Balance: <br>"\
                        "Order-Number:    Entry-Date:     Carrier-Number: <br>"\
                        "Supply-W 	Item-Id 	Qty 	Amount 	Delivery-Date <br>"\
                        "<button type=\"submit\" id=\"doSubmit\">Submit</button>"\
						"</form>"\
                        "<a href=\"/tpcc/txn-menu%s\">Menu</a>"\
						"</body>"\
						"</pre>"\
						"</html>"

#define sl_input_page	"<html>"\
                            "<head>"\
                            "<title>OceanBase|stock-level</title>"\
                            "</head>"\
							"<pre>"\
                            "<body>"\
    					"<h3>STOCK LEVEL</h3>"\
						"<form action=\"stock-level\" method=\"post\" id=\"sl_forms\">"\
						"<input type=\"hidden\" name=\"t_id\" value=\"%d\"/>"\
						"<input type=\"hidden\" name=\"sl_d_id\" value=\"%d\"/>"\
						"Warehouse:             <input name=\"w_id\" value=\"%d\" readonly /> "\
                        "District:    <input name=\"d_id\" value=\"%d\" readonly />	Date: <br>"\
                        "Stock Level Threshold: <input name=\"threshold\"/> <br>"\
                        "low stock:<br>"\
                        "<button type=\"submit\" id=\"doSubmit\">Submit</button>"\
						"</form>"\
                        "<a href=\"/tpcc/txn-menu%s\">Menu</a>"\
						"</body>"\
						"</pre>"\
						"</html>"

#define response_footer "</body></pre></html>"

#define TXN_EXEC_STATE_PREFIX  "Execution Status:"
#define TXN_EXEC_SUCCESS_MSG	"SUCCEED"
#define DEILIVERY_QUEUED_MSG	"Delivery has been queued"
#define TXN_EXEC_FAILURE_MSG	"FAILED"
#define INVALID_I_ID_MSG "Item number is not valid"

#define MAX_OL_NUM 15
typedef struct item
{
	int	ol_s_w_id;
	int	ol_i_id;
	int ol_quantity;
}ItemInfo;

typedef struct itemdetail
{
	int	ol_s_w_id;
	int	ol_i_id;
	char ol_i_name[25];
	int ol_quantity;
	int	ol_stock;
	char ol_b_g[2];
	double ol_i_price;
	double ol_amount;
}ItemDetailInfo;

typedef struct neworder
{
	int t_id;
	int w_id;
	int sl_d_id;
	int d_id;
	int c_id;
	int	o_id;
	double c_discount;
	double w_tax;
	double d_tax;
	char o_entry_d[30];
	char c_credit[3];
	char c_last[17];
	double total_amount;
	int retry;
	//--ItemInfo
	int sremote[MAX_OL_NUM];
	int alocal;
	int	o_ol_cnt_b;
	int	o_ol_cnt;
    int ol_s_w_id[MAX_OL_NUM];
    int ol_i_id[MAX_OL_NUM];
    char ol_i_name[MAX_OL_NUM][25];
    int ol_quantity[MAX_OL_NUM];
    int ol_stock[MAX_OL_NUM];
    char ol_b_g[MAX_OL_NUM][2];
    double ol_i_price[MAX_OL_NUM];
    double ol_amount[MAX_OL_NUM];	
	//char status[200];
}NewOrderInfo;

typedef struct payment
{
	int t_id;
	int w_id;
	int sl_d_id;
	int d_id;
	int	c_id;
	int c_w_id;
	int c_d_id;
	int blastname;
	int retry;
	//char h_amount[12];
	double h_amount;
	double c_credit_lim;
	double c_balance;
	double c_discount;
	char h_date[30];
	char w_street_1[21];
	char w_street_2[21];
	char w_city[21];
	char w_state[3];
	char w_zip[10];
	char d_street_1[21];
	char d_street_2[21];
	char d_city[21];
	char d_state[3];
	char d_zip[11];
	char c_first[17];
	char c_middle[3];
	char c_last[17];
	char c_street_1[21];
	char c_street_2[21];
	char c_city[21];
	char c_state[3];
	char c_zip[11];
	char c_phone[17];
	char c_since[30];
	char c_credit[3];
	char c_data[201];
	//char status[200];
}PaymentInfo;

typedef struct delivery
{
	int t_id;
	int w_id;
	int sl_d_id;
	int o_carrier_id; 
	char status[512];
}DeliveryInfo;

typedef struct orderitem
{
	int	ol_s_w_id;
	int	ol_i_id;
	int	ol_quantity;
	double ol_amount;
	char ol_delivery_d[30];
}OrderItemInfo;

typedef struct orderstatus
{
	int t_id;
	int w_id;
	int sl_d_id;
	int d_id;
	int c_id;
	int o_id;
	int o_carrier_id;
	int	o_ol_cnt;
	int blastname;
	double c_balance;
	char c_first[17];
	char c_middle[3];
	char c_last[17];
	char o_entry_d[30];
    int ol_s_w_id[MAX_OL_NUM];
    int ol_i_id[MAX_OL_NUM];
    int ol_quantity[MAX_OL_NUM];
    double ol_amount[MAX_OL_NUM];
    char ol_delivery_d[MAX_OL_NUM][30];
	//char status[200];
}OrderStatusInfo;

typedef struct stocklevel
{
	int t_id;
	int w_id;
	int d_id;
	int threshold; 
	int low_stock; 
	//char status[200];
}StockLevelInfo;

typedef struct new_order_param{
    NUMBER_STRUCT ol_i_id_num[MAX_OL_NUM];
    ARRAY_STRUCT ol_i_id_arr;

    NUMBER_STRUCT ol_s_w_id_num[MAX_OL_NUM];
    ARRAY_STRUCT ol_s_w_id_arr;

    NUMBER_STRUCT i_price_num[MAX_OL_NUM];
    ARRAY_STRUCT  i_price_arr;

    STRING_STRUCT i_name_str[MAX_OL_NUM];
    ARRAY_STRUCT  i_name_arr;

    NUMBER_STRUCT s_qty_num[MAX_OL_NUM];
    ARRAY_STRUCT  s_qty_arr;

    STRING_STRUCT b_g_str[MAX_OL_NUM];
    ARRAY_STRUCT  b_g_arr;

    NUMBER_STRUCT ol_amount_num[MAX_OL_NUM];
    ARRAY_STRUCT ol_amount_arr;

    NUMBER_STRUCT ol_qty_num[MAX_OL_NUM];
    ARRAY_STRUCT ol_qty_arr;

    int sremote[MAX_OL_NUM];
    NUMBER_STRUCT sremote_num[MAX_OL_NUM];
    ARRAY_STRUCT  sremote_arr;
}new_order_param;

typedef struct order_status_param{
    int blastname;

    NUMBER_STRUCT ol_i_id_num_2[MAX_OL_NUM];
    ARRAY_STRUCT ol_i_id_arr_2;

    NUMBER_STRUCT ol_s_w_id_num_2[MAX_OL_NUM];
    ARRAY_STRUCT ol_s_w_id_arr_2;

    NUMBER_STRUCT ol_amount_num_2[MAX_OL_NUM];
    ARRAY_STRUCT ol_amount_arr_2;

    NUMBER_STRUCT ol_qty_num_2[MAX_OL_NUM];
    ARRAY_STRUCT ol_qty_arr_2;

    STRING_STRUCT ol_del_d_str_2[MAX_OL_NUM];
    ARRAY_STRUCT ol_del_d_arr_2;
}order_status_param;

typedef struct traceinfo{
	long long int rte_send_ts;
	long long int get_rte_ts;
	long long int get_db_ts;
}TraceInfo;

typedef struct oceanbase_connection{
    TXN_TYPE txn_type;
    SQLHENV env;
    SQLHDBC dbc;
    SQLHSTMT stmts[TXN_TYPE_NUM];
    int estate;
    int need_reconn;
    int t_id;
    NewOrderInfo no_info;
    PaymentInfo pay_info;
    DeliveryInfo del_info;
    OrderStatusInfo os_info;
    StockLevelInfo sl_info;
    new_order_param no_param;
    order_status_param os_param;
    char params[1024];
    char msg[512];
    char dsn[128];
    char user[128];
    char password[128];
    int status;
	long long int total_txn_cnt;
	TraceInfo  trace_info;
}oceanbase_connection;

typedef int oceanbase_return_t;

int ob_free_conn(oceanbase_connection * obc);
int ob_get_conn_fd(oceanbase_connection * obc);
int ob_connect(oceanbase_connection *obc);
void ob_reset_conn(oceanbase_connection *dc);

#define OCEANBASE_RETURN_IO_WAIT 2
#define OCEANBASE_RETURN_OK 0
#define OCEANBASE_RETURN_ERROR_CODE -100
#define oceanbase_error_msg(ob) (ob)->msg

#endif
